/*
liba52 wrapper class
Copyright  2007 James Chapman
http://www.vuplayer.com

Utilizes the liba52 library
Copyright  2000-2002 Michel Lespinasse <walken@zoy.org>
Copyright  1999-2000 Aaron Holtzman <aholtzma@ess.engr.uvic.ca>
http://liba52.sourceforge.net/
*/

#pragma once

#include <stdio.h>
#include <liba52/a52.h>

#define AC3_FRAMESIZE	3840
#define AC3_BLOCKSIZE	256
#define AC3_BLOCKCOUNT	6
#define AC3_BUFSIZE		AC3_BLOCKSIZE*AC3_BLOCKCOUNT*2

class Cac3
{
public:
	Cac3();
	virtual ~Cac3();
	void Close();
	bool Open(const char* filename, float scale=1.0f, bool drc=0);
	int Read(float* buf, int bytes);
	
	int m_flags;
	int m_bitrate;
	int m_samplerate;
	__int64 m_totalsamples;

private:
	FILE* m_file;
	float m_scale;
	bool m_drc;
	int m_bufpos;
	a52_state_t* m_state;
	uint8_t m_frame[AC3_FRAMESIZE];
	float m_buf[AC3_BUFSIZE];

	int GetFrame();
};
